﻿using UnityEngine;
using UnityEngine.UI;

public class MainUI : MonoBehaviour
{
    public GameObject heartGraphicPrefab;
    public Text timerText;
    public RectTransform heartHolder;
    public Text waveTargetText;
	public Text waveGoalText;
    public Image waveRechargeIndicator;

	public Image fill;
	public GameObject pin;
	public Rigidbody player;

    protected float _waveRechargeTime;




	public void Update()
	{
		float timeLeft = GameManager.Instance.gameEndTime-Time.time;
		timerText.text = (int)timeLeft / 60 + ":" + (timeLeft % 60 < 10 ? "0" : "") + (int)timeLeft % 60;
		waveTargetText.text = GameManager.Instance.currentWaves.ToString();
		waveGoalText.text = GameManager.Instance.waveTarget.ToString();
		waveRechargeIndicator.fillAmount = 1 - ((_waveRechargeTime - Time.time) / ViewArea.WAVE_REACHARGE);

		Quaternion target = Quaternion.Euler (0,0,Mathf.Clamp (93 - player.velocity.magnitude*3,-4,93));
		pin.transform.rotation = Quaternion.Slerp (pin.transform.rotation, target, Time.deltaTime*2);
		fill.fillAmount = .24f + .27f * (float)(GameManager.Instance.currentWaves / (float)GameManager.Instance.waveTarget);
	}


    public void AddHeart()
    {
        GameObject heartObject = GameObject.Instantiate(heartGraphicPrefab, heartHolder);
        heartObject.transform.localScale = new Vector3(1.0f, 1.0f, 1.0f);
    }

    public void ClearHearts()
    {
        foreach(RectTransform child in heartHolder)
        {
            GameObject.Destroy(child.gameObject);
        }
    }

    public void RemoveHeart()
    {
        RectTransform last = null;
        foreach(RectTransform t in heartHolder)
        {
            last = t;
        }
        GameObject.Destroy(last.gameObject);
    }

    public void SetWaveRechargeTime(float rechargeTime)
    {
        _waveRechargeTime = rechargeTime;
    }
}