﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PopeController : MonoBehaviour
{
    public Plane groundPlane;

    void Awake()
    {
        groundPlane = new Plane(Vector3.up, transform.position);
    }

    void Update()
    {
        Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);
        float rayDistance;
        if (groundPlane.Raycast(ray, out rayDistance))
        {
			Vector3 lookPos = ray.GetPoint(rayDistance) - transform.position;
			lookPos.y = 0;
			Vector3 rot = Quaternion.Slerp (transform.rotation, Quaternion.LookRotation (lookPos), Time.deltaTime * 1000).eulerAngles;
			transform.localRotation = Quaternion.Euler (new Vector3 (0, rot.y - transform.parent.rotation.eulerAngles.y - 90, 0));
        }
    }
}